//
//  stack.cpp
//  C++ program illustrates object?oriented programming
//  with a classical stack operation using a string of
//  characters.
//  Copyright (c) Chris H. Pappas and William H. Murray, 2001
//

#include "stdafx.h"
#include <iostream>

using namespace std;

#define maxlen 80

class stack {
    char str1[maxlen];
    int  first;

public:
    void clear(void);
    char top(void);
    int  empty(void);
    int  full(void);
    void push(char chr);
    char pop(void);
};

void stack::clear(void)
{
    first = 0;
}

char stack::top(void)
{
    return (str1[first]);
}

int stack::empty(void)
{
    return (first == 0);
}

int stack::full(void)
{
    return (first == maxlen - 1);
}

void stack::push(char chr)
{
    str1[++first] = chr;
}

char stack::pop(void)
{
    return (str1[first--]);
}

int main(int argc, char* argv[])
{
    stack mystack;
    char str[11] = "0123456789";
    int length;

    // clear the stack
    mystack.clear( );

    // load the string, char by char, on the stack
    cout << "\nLoad character data on stack" << endl;
    length = strlen(str);
    for(int i = 0; i < length; i++) {
        if (!mystack.full( ))
            mystack.push(str[i]);
        cout << str[i] << endl;
    }

    // unload the stack, char by char
    cout << "\nUnload character data from stack" << endl;
    while (!mystack.empty( ))
        cout << mystack.pop( ) << endl;
    cout << endl << endl;
  
    return 0;
}

